import { SQL } from 'drizzle-orm';
import { GraphQLInputObjectType, GraphQLList, GraphQLNonNull, GraphQLObjectType } from 'graphql';
import type { Column, Table } from 'drizzle-orm';
import type { GraphQLResolveInfo } from 'graphql';
import type { FilterColumnOperators, Filters, OrderByArgs } from './types';
export declare const extractSelectedColumns: (info: GraphQLResolveInfo, queryName: string) => {
    [k: string]: true;
};
export declare const extractSelectedColumnsSQLFormat: <TTable extends Table<import("drizzle-orm").TableConfig<Column<any, object, object>>>>(info: GraphQLResolveInfo, queryName: string, table: TTable) => Record<string, Column>;
export declare const innerOrder: GraphQLInputObjectType;
export declare const generateTableTypes: (tableName: string, table: Table) => {
    inputs: {
        insertInput: GraphQLInputObjectType;
        updateInput: GraphQLInputObjectType;
        tableOrder: GraphQLInputObjectType;
        tableFilters: GraphQLInputObjectType;
    };
    outputs: {
        selectSingleOutput: GraphQLObjectType<any, any>;
        selectArrOutput: GraphQLNonNull<GraphQLList<GraphQLNonNull<GraphQLObjectType<any, any>>>>;
    };
};
export declare const extractOrderBy: <TTable extends Table<import("drizzle-orm").TableConfig<Column<any, object, object>>>, TArgs extends OrderByArgs<any> = OrderByArgs<TTable>>(table: TTable, orderArgs: TArgs) => SQL[];
export declare const extractFiltersColumn: <TColumn extends Column<import("drizzle-orm").ColumnBaseConfig<import("drizzle-orm").ColumnDataType, string>, object, object>>(column: TColumn, columnName: string, operators: FilterColumnOperators<TColumn>) => SQL | undefined;
export declare const extractFilters: <TTable extends Table<import("drizzle-orm").TableConfig<Column<any, object, object>>>>(table: TTable, tableName: string, filters: Filters<TTable>) => SQL | undefined;
